package eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class LookupAction extends Action {

  protected Double getCotation(String symbole) {

    if ( symbole.equalsIgnoreCase("SUNW") ) {

      return new Double(25.00);
    }
    return null;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    Double cours = null;

    // Cible par dfaut
    String cible = new String("succes");

    if ( form != null ) {

      // Utilisation de LookupForm pour obtenir les paramtres de la requte
      LookupForm lookupForm = (LookupForm)form;

      String symbole = lookupForm.getSymbole();

      cours = getCotation(symbole);
    }

    // Cible en cas d'chec
    if ( cours == null ) {

      cible = new String("echec");
    }
    else {

      request.setAttribute("COURS", cours);
    }
    // Transmission  la vue approprie
    return (mapping.findForward(cible));
  }
}
