package eyrolles;

import java.util.Properties;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletContext;

import org.apache.struts.action.PlugIn;
import org.apache.struts.config.ApplicationConfig;
import org.apache.struts.action.ActionServlet;

public class EyrollesPlugin implements PlugIn {

  public static final String PROPERTIES = "PROPERTIES";
  
  public void init(ActionServlet servlet,
    ApplicationConfig applicationConfig)
    throws javax.servlet.ServletException {

    System.out.println("---->Le plug-in dmarre<----");
    Properties properties = new Properties();

    try {

      File file =
        new File("C:\\Program Files\\Apache Group\\Tomcat 4.1\\webapps\\eyrollesstruts\\WEB-INF\\props.txt");

      FileInputStream fis =
        new FileInputStream(file);

      properties.load(fis);

      ServletContext context = servlet.getServletContext();
      context.setAttribute(PROPERTIES, properties);

      Properties rProperties = (Properties)context.getAttribute(PROPERTIES);
      System.err.println("---->Prop: LDAP " + rProperties.getProperty("LDAP"));
    }
    catch (FileNotFoundException fnfe) {

      throw new ServletException(fnfe.getMessage());
    }
    catch (IOException ioe) {

      throw new ServletException(ioe.getMessage());
    }
  }

  public void destroy() {

    System.out.println("---->Le plug-in s'arrte<----");
  }
}
