package com.eyrolles;

import java.io.IOException;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class AddEmployeAction extends Action {

  protected void insertUser(ActionForm form)
    throws Exception {

    String user = null;
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    ServletContext context = servlet.getServletContext();
    DataSource dataSource = (DataSource)
      context.getAttribute(Action.DATA_SOURCE_KEY);

    try {

      EmployeForm eForm = (EmployeForm)form;
      conn = dataSource.getConnection();
      stmt = conn.createStatement();

      StringBuffer sqlString =
        new StringBuffer("insert into employes ");

      sqlString.append("values (\""
        + eForm.getUsername() + "\", ");
      sqlString.append("\"" +
        eForm.getPassword() + "\", ");
      sqlString.append("\""
        + eForm.getRoleid() + "\", ");
      sqlString.append("\""
        + eForm.getName() + "\", ");
      sqlString.append("\""
        + eForm.getPhone() + "\", ");
      sqlString.append("\""
        + eForm.getEmail() + "\", ");
      sqlString.append("\""
        + eForm.getDepid() + "\")");

      stmt.execute(sqlString.toString());
    }
    finally {

      if (rs != null) {

          rs.close();
      }
      if (stmt != null) {

          stmt.close();
      }
      if (conn != null) {

          conn.close();
      }
    }
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    // Cible par dfaut en cas de succs
    String target = new String("success");

    EmployesActionMapping employesMapping =
      (EmployesActionMapping)mapping;

    // Cette action ncessite-t-elle l'identification de l'utilisateur ?
    if ( employesMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        // L'utilisateur n'est pas identifi
        target = new String("login");
        ActionErrors errors = new ActionErrors();

        errors.add(ActionErrors.GLOBAL_ERROR,
          new ActionError("errors.login.required"));

        // Renvoyer les erreurs au formulaire originel
        if (!errors.empty()) {

          saveErrors(request, errors);
        }
      }
    }

    if ( isCancelled(request) ) {

      // Annulation. Retour  la liste des employs
      return (mapping.findForward("success"));
    }

    try {

      insertUser(form);
    }
    catch (Exception e) {

      System.err.println("Setting target to error");
      target = new String("error");
      ActionErrors errors = new ActionErrors();

      errors.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("errors.database.error", e.getMessage()));

      // Signalement des erreurs ventuelles
      if (!errors.empty()) {

        saveErrors(request, errors);
      }
    }
    // Transmission  la vue approprie
    return (mapping.findForward(target));
  }
}