package com.eyrolles;

import java.io.IOException;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class DeleteEmployeAction extends Action {

  protected void deleteEmploye(String username)
    throws Exception {

    String user = null;
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    ServletContext context = servlet.getServletContext();
    DataSource dataSource = (DataSource)
      context.getAttribute(Action.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();

      StringBuffer sqlString =
        new StringBuffer("delete from employes ");
      sqlString.append("where username='" + username + "'");

      stmt.execute(sqlString.toString());
    }
    finally {

      if (rs != null) {

        rs.close();
      }
      if (stmt != null) {

        stmt.close();
      }
      if (conn != null) {

        conn.close();
      }
    }
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    // Cible par dfaut en cas de succs
    String target = new String("success");

    EmployesActionMapping employesMapping =
      (EmployesActionMapping)mapping;

    // Cette action ncessite-t-elle que l'utilisateur soit identifi ?
    if ( employesMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        // L'utilisateur n'est pas identifi
        target = new String("login");
        ActionErrors errors = new ActionErrors();

        errors.add(ActionErrors.GLOBAL_ERROR,
          new ActionError("errors.login.required"));

        // Signaler les erreurs ventuelles
        // au formulaire originel
        if (!errors.empty()) {

          saveErrors(request, errors);
        }
      }
    }

    try {

      deleteEmploye(request.getParameter("username"));
    }
    catch (Exception e) {

      target = new String("error");
      ActionErrors errors = new ActionErrors();

      errors.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("errors.database.error",
        e.getMessage()));

      // Signaler les erreurs ventuelles
      if (!errors.empty()) {

        saveErrors(request, errors);
      }
    }
    // Transmission  la vue approprie
    return (mapping.findForward(target));
  }
}