package com.eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class GetEmployeAction extends Action {

  protected ActionForm buildEmployeForm(String username) throws Exception {

    String user = null;
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;
    EmployeForm form = null;

    DataSource dataSource = (DataSource)
      servlet.getServletContext().getAttribute(Action.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();
      rs = stmt.executeQuery("select * from employes where username=\'"
        + username + "'");

      if ( rs.next() ) {

        form = new EmployeForm();

        form.setUsername(rs.getString("username"));
        form.setPassword(rs.getString("password"));
        form.setDepid(rs.getString("depid"));
        form.setRoleid(rs.getString("roleid"));
        String name = rs.getString("name");
        System.err.println("---->" + name + "<----");
        form.setName(name);
        form.setPhone(rs.getString("phone"));
        form.setEmail(rs.getString("email"));
      }
      else {

        throw new Exception("Employ " + username + " non trouv!");
      }
    }
    finally {

      if (rs != null) {

          rs.close();
      }
      if (stmt != null) {

          stmt.close();
      }
      if (conn != null) {

          conn.close();
      }
    }
    return form;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    // Cible par dfaut en cas de succs
    String target = new String("success");

    EmployesActionMapping employesMapping =
      (EmployesActionMapping)mapping;

    // Cette action ncessite-t-elle que l'utilisateur soit identifi ?
    if ( employesMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        // L'utilisateur n'est pas identifi
        target = new String("login");
        ActionErrors errors = new ActionErrors();

        errors.add(ActionErrors.GLOBAL_ERROR,
          new ActionError("errors.login.required"));

        // Retourner les erreurs ventuelles au formulaire d'origine
        if (!errors.empty()) {

          saveErrors(request, errors);
        }
      }
    }

    if ( isCancelled(request) ) {

      // Annulation depuis la liste des employs
      return (mapping.findForward(target));
    }

    try {

      form = buildEmployeForm(request.getParameter("username"));
      
      if ( form == null ) {
      
        System.err.println("---->form est null<----");
      }
      
      if ("request".equals(mapping.getScope())) {
      
        System.err.println("---->request<----");
        request.setAttribute(mapping.getAttribute(), form);
        System.err.println("---->request<----");
      }
      else {
      
        System.err.println("---->session<----");
        HttpSession session = request.getSession();
        System.err.println("---->session<----");
        session.setAttribute(mapping.getAttribute(), form);
      }
    }
    catch (Exception e) {

      System.err.println("Setting target to error");
      System.err.println("---->" + e.getMessage() + "<----");
      target = new String("error");
      ActionErrors errors = new ActionErrors();

      errors.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("errors.database.error", e.getMessage()));

      // Retourner les erreurs ventuelles
      if (!errors.empty()) {

        saveErrors(request, errors);
      }
    }
    // Transmettre la requite  la vue approprie
    return (mapping.findForward(target));
  }
}