package com.eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class LoginAction extends Action {

  protected String getUser(String username, String password) {

    String user = null;
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    DataSource dataSource = (DataSource)
      servlet.getServletContext().getAttribute(Action.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();
      rs = stmt.executeQuery("select * from employes where username=\'"
        + username + "' "
        + "and password='" + password + "'");

      if ( rs.next() ) {

        user = rs.getString("username");
        // Iteration sur le rsultat
        System.err.println("Username : "
          + rs.getString("username")
          + " Password : " + rs.getString("password"));
      }
      else {

        System.err.println("---->Utilisateur non trouv<----");
      }
    }
    catch (SQLException e) {

      System.err.println(e.getMessage());
    }
    finally {

      if (rs != null) {

        try {

          rs.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        rs = null;
      }
      if (stmt != null) {

        try {

          stmt.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        stmt = null;
      }
      if (conn != null) {

        try {

          conn.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        conn = null;
      }
    }
    return user;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    String user = null;

    // Cible par dfaut en cas de succs
    String target = new String("success");

    // Utilisation de LoginForm pour obtenir les paramtres 
    // de la requte
    String username = ((LoginForm)form).getUsername();
    String password = ((LoginForm)form).getPassword();

    user = getUser(username, password);

    // Cible en cas d'chec
    if ( user == null ) {

      target = new String("login");
      ActionErrors errors = new ActionErrors();

      errors.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("errors.login.unknown",
                        username));

      // Enregistrer les erreurs  trouves dans le formulaire original
      if (!errors.empty()) {

        saveErrors(request, errors);
      }
    }
    else {

      HttpSession session = request.getSession();
      session.setAttribute("USER", user);
    }
    // Transmission de la requte  la vue approprie
    return (mapping.findForward(target));
  }
}
