package com.eyrolles;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

public class LoginForm extends ActionForm {

  private String motDePasse = null;

  private String nomUtilisateur = null;

  public String getMotDePasse() {

    return (this.motDePasse);
  }

  public void setMotDePasse(String motDePasse) {

    this.motDePasse = motDePasse;
  }

  public String getNomUtilisateur() {

    return (this.nomUtilisateur);
  }

  public void setNomUtilisateur(String nomUtilisateur) {

    this.nomUtilisateur = nomUtilisateur;
  }

  public void reset(ActionMapping mapping, HttpServletRequest request) {

    this.motDePasse = null;
    this.nomUtilisateur = null;
  }

  public ActionErrors validate(ActionMapping mapping,
    HttpServletRequest request) {

    ActionErrors errors = new ActionErrors();

    if ( (nomUtilisateur == null ) || (nomUtilisateur.length() == 0) ) {

      errors.add("nomUtilisateur", 
                  new ActionError("errors.nomUtilisateur.required"));
    }
    if ( (motDePasse == null ) || (motDePasse.length() == 0) ) {

      errors.add("motDePasse", new ActionError("errors.motDePasse.required"));
    }
    return errors;
  }
}
